.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

  LOOP_COUNT	= 10000
  LocBytes	= MAX_PATH

csize macro algo, diff
LOCAL  tmp$
  tmp$ CATSTR <algo>, <            >	;; 12 blanks
  tmp$ SUBSTR tmp$, 1, 12
  tmp$ CATSTR <print ">, tmp$, < = ">
  tmp$
  mov eax, offset &algo&_END-&algo&
  ifnb <diff>
	sub eax, diff			;; correction for stack frame and ret
  endif
  print str$(eax), 13, 10
ENDM

ZEROLOCALES MACRO dernierelocale:REQ
   mov edx,edi
   mov ecx,ebp
   lea edi,dernierelocale
   sub ecx,edi
   xor eax,eax
   shr ecx,2
   rep stosd
   mov edi,edx   
ENDM

ClearLocVars macro	; 10 bytes, trashes eax
  mov eax, esp
  mov esp, ebp	; base page of calling procedure
@@:
  push 0
  cmp esp, eax
  ja @B
endm

cll macro
LOCAL cll_end
mov eax,esp
sub eax,ebp
jz cll_end
@@: mov DWORD ptr [ebp+eax],0
add eax,4
jnz @B
@@:
cll_end:
endm

.code
AppName	db "Masm32:", 0
HiWorld1	db "Hello World with call", 0
HiWorld2	db "Hello World with macro", 0

start:
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call MyTest1
	counter_end
	print str$(eax), 9, "cycles for ZEROLOCALES, eax+ecx+edx trashed", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call MyTest2
	counter_end
	print str$(eax), 9, "cycles for cll, eax trashed", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call MyTest3
	counter_end
	print str$(eax), 9, "cycles for ClearLocVars, eax trashed", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call MyTest4
	counter_end
	print str$(eax), 9, "cycles for call ClearLocalsB, eax trashed", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call MyTest5
	counter_end
	print str$(eax), 9, "cycles for call ClearLocals, ALL regs preserved", 13, 10

	print chr$(13, 10, "Code sizes:", 13, 10)
	csize MyTest1, 11
	csize MyTest2, 11
	csize MyTest3, 11
	csize MyTest4, 11
	csize MyTest5, 11
	print chr$(13, 10, "plus once for procs:", 13, 10)
	csize ClearLocalsB
	csize ClearLocals

	getkey
	exit

MyTest1 proc
LOCAL MyVar1:DWORD, LocBuffer[LocBytes]:BYTE, MyVar2:DWORD
  ZEROLOCALES MyVar2
  ret
MyTest1 endp
MyTest1_END:

MyTest2 proc
LOCAL MyVar1:DWORD, LocBuffer[LocBytes]:BYTE, MyVar2:DWORD
  cll
  ret
MyTest2 endp
MyTest2_END:

MyTest3 proc
LOCAL MyVar1:DWORD, LocBuffer[LocBytes]:BYTE, MyVar2:DWORD
  ClearLocVars
  ret
MyTest3 endp
MyTest3_END:

MyTest4 proc
LOCAL MyVar1:DWORD, LocBuffer[LocBytes]:BYTE, MyVar2:DWORD
  call ClearLocalsB
  ret
MyTest4 endp
MyTest4_END:

MyTest5 proc
LOCAL MyVar1:DWORD, LocBuffer[LocBytes]:BYTE, MyVar2:DWORD
  call ClearLocals
  ret
MyTest5 endp
MyTest5_END:

ClearLocalsB proc		; put "call ClearLocals" as first instruction after LOCALS - eax will be esp+4 on exit
  lea eax, [esp+4]
  mov esp, ebp			; base page of calling procedure
@@:
  push 0
  cmp esp, eax
  ja @B
  jmp dword ptr [eax-4]		; 15 bytes
ClearLocalsB endp
ClearLocalsB_END:

ClearLocals proc		; put "call ClearLocals" as first instruction after LOCALS - eax will be unchanged on exit
  push eax
  lea eax, [esp+8]
  mov esp, ebp			; base page of calling procedure
@@:
  push 0
  cmp esp, eax
  ja @B
  sub esp, 8				; 18 bytes
  pop eax
  ret
ClearLocals endp
ClearLocals_END:

oClearLocals proc			; put "call ClearLocals" as first instruction after LOCALS - eax will be zero on exit
.data?
	EspGlob	dd ?
.code
	pop EspGlob	; save the return address to a global variable - now
					; the stack is identical to the calling procedure	
	xchg eax, ecx	; save ecx
	mov ecx, ebp	; base page of calling procedure
	sub ecx, esp	; ebp - esp = No. of bytes in locals
	mov esp, ebp	; discard existing locals
	shr ecx, 2		; divide by four
@@:	push 0			; dwords on stack
	loop @B
	xchg eax, ecx	; restore ecx, 0 to eax
	push EspGlob	; restore the return address
	ret
oClearLocals endp

end start
OPT_WAIT	0
OPT_Tmp2Asm	1
